gtkmm: Gtk::AppChooser Class Reference

gtkmm 3.24.6

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::AppChooser Class Reference

Interface implemented by widgets for choosing an application. More...

`#include <gtkmm/appchooser.h>`

Inheritance diagram for Gtk::AppChooser:
[legend]

## Public Member Functions
| AppChooser (AppChooser && src) noexcept
AppChooser & | operator= (AppChooser && src) noexcept
| ~AppChooser () noexcept override
GtkAppChooser * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkAppChooser * | gobj () const
| Provides access to the underlying C GObject. More...
Glib::RefPtr< Gio::AppInfo > | get_app_info ()
| Returns the currently selected application. More...
Glib::RefPtr< const Gio::AppInfo > | get_app_info () const
| Returns the currently selected application. More...
Glib::ustring | get_content_type () const
| Returns the current value of the Gtk::AppChooser::property_content_type() property. More...
void | refresh ()
| Reloads the list of applications. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_content_type () const
| The content type of the Gtk::AppChooser object. More...
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| AppChooser ()
| You should derive from this class to use it. More...
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::AppChooser > | wrap (GtkAppChooser * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Interface implemented by widgets for choosing an application.

This interface can be implemented by widgets which allow the user to choose an application (typically for the purpose of opening a file). The main objects that implement this interface are AppChooserWidget, AppChooserDialog and AppChooserButton.

Applications are represented by Gio::AppInfo objects here. GIO has a concept of recommended and fallback applications for a given content type. Recommended applications are those that claim to handle the content type itself, while fallback also includes applications that handle a more generic content type. GIO also knows the default and last-used application for a given content type. The AppChooserWidget provides detailed control over whether the shown list of applications should include default, recommended or fallback applications.

To obtain the application that has been selected in an AppChooser, use get_app_info().

See Platform-specific content typing in glibmm for more information about content types.

Since gtkmm 3.0:

## Constructor & Destructor Documentation

## ◆ AppChooser() [1/2]

Gtk::AppChooser::AppChooser | ( |  | ) |
| protected

You should derive from this class to use it.

## ◆ AppChooser() [2/2]

Gtk::AppChooser::AppChooser | ( | AppChooser && | src | ) |
| noexcept

## ◆ ~AppChooser()

Gtk::AppChooser::~AppChooser | ( |  | ) |
| overridenoexcept

## Member Function Documentation

## ◆ add_interface()

static void Gtk::AppChooser::add_interface | ( | GType | gtype_implementer | ) |
| static

## ◆ get_app_info() [1/2]

Glib::RefPtr< Gio::AppInfo > Gtk::AppChooser::get_app_info | ( |  | ) |

Returns the currently selected application.

Since gtkmm 3.0:

Returns
  A Gio::AppInfo for the currently selected application, or `nullptr` if none is selected. Free with Glib::object_unref().

## ◆ get_app_info() [2/2]

Glib::RefPtr< const Gio::AppInfo > Gtk::AppChooser::get_app_info | ( |  | ) | const

Returns the currently selected application.

Since gtkmm 3.0:

Returns
  A Gio::AppInfo for the currently selected application, or `nullptr` if none is selected. Free with Glib::object_unref().

## ◆ get_content_type()

Glib::ustring Gtk::AppChooser::get_content_type | ( |  | ) | const

Returns the current value of the Gtk::AppChooser::property_content_type() property.

Since gtkmm 3.0:

Returns
  The content type of self.

## ◆ get_type()

static GType Gtk::AppChooser::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkAppChooser * Gtk::AppChooser::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkAppChooser * Gtk::AppChooser::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ operator=()

AppChooser & Gtk::AppChooser::operator= | ( | AppChooser && | src | ) |
| noexcept

## ◆ property_content_type()

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::AppChooser::property_content_type | ( |  | ) | const

The content type of the Gtk::AppChooser object.

See [GContentType][gio-GContentType] for more information about content types.

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ refresh()

void Gtk::AppChooser::refresh | ( |  | ) |

Reloads the list of applications.

Since gtkmm 3.0:

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::AppChooser > wrap | ( | GtkAppChooser * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.